Description

The documentation at http://docs.ceph.com/docs/master/mgr/dashboard/#enabling-the-object-gateway-management-frontend

currently makes an unequivocal statement:

"This is all you have to do to get the Object Gateway management functionality working. The host and port of the Object Gateway are

determined automatically."

However, with the advent of Beast this is no longer the case.

In the "RGW always uses civetweb" paradigm, the RGW port could be determined automatically using a regex that matches port={},

like so:

match = re.search(r'port=(.*:)?(\d+)(s)?', config)

 

But nowadays, assuming the dashboard should also support Beast, that regex is broken because Beast has different semantics for

specifying the RGW endpoint. For example, the relevant line in ceph.conf might look like this:

rgw frontends = "beast endpoint=[::]:80" 

 

I'm not sure what the "correct" regex should be. Should it support both Civetweb and Beast, or just one or the other?

Should it support both IPv4 and IPv6?

(My thanks to Ricardo Marques for helping gather the above information.)

Related issues:

Copied to Dashboard - Backport #44203: nautilus: mgr/dashboard: RGW port auto... Resolved

History

#1 - 04/11/2019 03:20 PM - Nathan Cutler

- Category set to 143

#2 - 04/11/2019 03:22 PM - Nathan Cutler

- Description updated

#3 - 04/11/2019 03:27 PM - Lenz Grimmer
http://docs.ceph.com/docs/master/mgr/dashboard/#enabling-the-object-gateway-management-frontend


- Subject changed from dashboard: RGW port autodetection does not support beast to mgr/dashboard: RGW port autodetection does not support

beast

- Description updated

- Target version set to v15.0.0

- Backport set to nautilus

#4 - 04/11/2019 03:52 PM - Nathan Cutler

- Subject changed from mgr/dashboard: RGW port autodetection does not support beast to mgr/dashboard: RGW port autodetection does not support

"Beast" RGW frontend

#5 - 04/11/2019 03:52 PM - Nathan Cutler

I was told that the Beast frontend supports "port=" as well as "endpoint=", so maybe the fix is simpler than I thought?

#6 - 04/12/2019 08:28 AM - Nathan Cutler

One further point. Though I am by far not an expert on RGW/Beast, my understanding is that the "endpoint" configuration line that is being parsed by

this regex could potentially be quite complicated - even with multiple endpoints.

In that light, would it make sense to mention these possible complications in the documentation? I.e. instead of the unequivocal statement

"This is all you have to do to get the Object Gateway management functionality working. The host and port of the Object Gateway are determined

automatically."

it could be more careful and say something like:

"In a typical default configuration with a single RGW endpoint, this is all you have to do to get the Object Gateway management functionality working.

The dashboard will try to automatically determine the host and port of the Object Gateway by parsing the relevant line in ceph.conf."

#7 - 04/12/2019 09:13 AM - Marcus Watts

The civetweb interface has supported multiple ports and optional host or ssl for a while now.

So, for instance,

rgw_frontends = civetweb port=80+443s ssl_certificate=/etc/ceph/private/keyandcert.pem

Last I checked, ceph-ansible wasn't very good about this, but it also wasn't very good about ssl either.

#8 - 04/12/2019 10:45 AM - Lenz Grimmer

Nathan Cutler wrote:

One further point. Though I am by far not an expert on RGW/Beast, my understanding is that the "endpoint" configuration line that is being

parsed by this regex could potentially be quite complicated - even with multiple endpoints.

In that light, would it make sense to mention these possible complications in the documentation? I.e. instead of the unequivocal statement

"This is all you have to do to get the Object Gateway management functionality working. The host and port of the Object Gateway are

determined automatically."

it could be more careful and say something like:

"In a typical default configuration with a single RGW endpoint, this is all you have to do to get the Object Gateway management functionality

03/13/2024 2/5



working. The dashboard will try to automatically determine the host and port of the Object Gateway by parsing the relevant line in ceph.conf."

 

Sounds good to me, except for the last part - the dashboard actually obtains this information from the service map, not ceph.conf. I'll update the

documentation accordingly, until we have found a more generic solution for this.

#9 - 04/15/2019 07:36 AM - Lenz Grimmer

Lenz Grimmer wrote:

Nathan Cutler wrote:

One further point. Though I am by far not an expert on RGW/Beast, my understanding is that the "endpoint" configuration line that is being

parsed by this regex could potentially be quite complicated - even with multiple endpoints.

In that light, would it make sense to mention these possible complications in the documentation? I.e. instead of the unequivocal statement

"This is all you have to do to get the Object Gateway management functionality working. The host and port of the Object Gateway are

determined automatically."

it could be more careful and say something like:

"In a typical default configuration with a single RGW endpoint, this is all you have to do to get the Object Gateway management functionality

working. The dashboard will try to automatically determine the host and port of the Object Gateway by parsing the relevant line in

ceph.conf."

 

Sounds good to me, except for the last part - the dashboard actually obtains this information from the service map, not ceph.conf. I'll update the

documentation accordingly, until we have found a more generic solution for this.

 

Docs pull request: https://github.com/ceph/ceph/pull/27581 - please review.

#10 - 04/16/2019 01:30 PM - Lenz Grimmer
https://github.com/ceph/ceph/pull/27581


In general, when enhancing the autodetection, we should ensure that it also supports IPv6 addresses

#11 - 05/22/2019 11:35 AM - Lenz Grimmer

- Target version deleted (v15.0.0)

- Affected Versions v14.2.0, v14.2.1, v15.0.0 added

The documentation has been updated. Leaving this one open, as the dashboard implementation itself should be enhanced.

#12 - 01/30/2020 01:57 PM - Lenz Grimmer

- Tags changed from usability to usability, feature-gap

- Regression changed from No to Yes

#13 - 01/30/2020 01:58 PM - Lenz Grimmer

- Tags changed from usability, feature-gap to usability, feature-gap, low-hanging-fruit

- Severity changed from 3 - minor to 2 - major

#14 - 01/30/2020 02:22 PM - Lenz Grimmer

- Tags changed from usability, feature-gap, low-hanging-fruit to usability, feature-gap

#15 - 01/30/2020 02:24 PM - Lenz Grimmer

- Assignee set to Volker Theile

#16 - 01/30/2020 04:26 PM - Abhishek Lekshmanan

so with beast port=<> would bind to both ipv4 and v6, endpoint binds to the ip:port combination which can be v4 or v6

with civetweb port=<> would bind to a v4 port if it is just a number. It can also be a ip:port combo in which case both v4 and v6 endpoints are

supported

See https://docs.ceph.com/docs/master/radosgw/frontends/#id1 for some additional info

#17 - 02/04/2020 02:06 PM - Volker Theile

- Status changed from New to Fix Under Review

- Pull request ID set to 33060

#18 - 02/19/2020 09:52 AM - Lenz Grimmer

- Status changed from Fix Under Review to Pending Backport

- Target version set to v15.0.0

#19 - 02/19/2020 10:01 AM - Konstantin Shalygin

- Copied to Backport #44203: nautilus: mgr/dashboard: RGW port autodetection does not support "Beast" RGW frontend added

#20 - 05/21/2020 05:41 PM - Nathan Cutler

- Status changed from Pending Backport to Resolved

While running with --resolve-parent, the script "backport-create-issue" noticed that all backports of this issue are in status "Resolved" or "Rejected".

#21 - 04/15/2021 05:26 PM - Ernesto Puerta

- Project changed from mgr to Dashboard
https://docs.ceph.com/docs/master/radosgw/frontends/#id1


- Category changed from 143 to Component - RGW
